# ref: https://setuptools.pypa.io/en/stable/userguide/pyproject_config.html
[project]
authors = [{ name = "Henry Webel", email = "heweb@dtu.dk" }]
description = "A small example package"
name = "python_package"
# This means: Load the version from the package itself.
# See the section below: [tools.setuptools.dynamic]
dynamic = [
  "version", # version is loaded from the package
  #"dependencies", # add if using requirements.txt
]
readme = "README.md"
requires-python = ">=3.9" # test all higher Python versions
# These are keywords
classifiers = [
  "Programming Language :: Python :: 3",
  "Operating System :: OS Independent",
]
# Also update LICENSE file if you pick another one
license = "GPL-3.0-or-later" # https://choosealicense.com/licenses/gpl-3.0/
# # add dependencies here: (use one of the two)
# dependencies = ["numpy", "pandas", "scipy", "matplotlib", "seaborn"]
# use requirements.txt instead of pyproject.toml for dependencies
# https://stackoverflow.com/a/73600610/9684872
# ! uncomment also dependencies in the dynamic section above
# [tool.setuptools.dynamic]
# dependencies = {file = ["requirements.txt"]}


[project.urls]
"Bug Tracker" = "https://github.com/Multiomics-Analytics-Group/streamlit_demo/issues"
"Homepage" = "https://github.com/Multiomics-Analytics-Group/streamlit_demo"

[project.optional-dependencies]
# Optional dependencies to locally build the documentation, also used for 
# readthedocs.
docs = [
  "sphinx",
  "sphinx-book-theme",
  "myst-nb",
  "ipywidgets",
  "sphinx-new-tab-link!=0.2.2",
  "jupytext",
  "sphinx-copybutton",
]
# local development options
dev = ["black[jupyter]", "ruff", "pytest", "isort", "jupytext"]

[tool.ruff]
# https://docs.astral.sh/ruff/rules/#flake8-bandit-s

[tool.ruff.lint]
# https://docs.astral.sh/ruff/tutorial/#rule-selection
# 1. Enable flake8-bugbear (`B`) rules
# 2. Enable pycodestyle (`E`) errors and (`W`) warnings
# 3. Pyflakes (`F`) errors
extend-select = ["E", "W", "F", "B"]
# Ignore line length errors:
# ignore = ["E501"]

[build-system]
build-backend = "setuptools.build_meta"
requires = ["setuptools>=64", "setuptools_scm>=8"]

[tool.setuptools_scm]
# https://setuptools-scm.readthedocs.io/ 
# used to pick up the version from the git tags or the latest commit.

[tool.isort]
profile = "black"

# Script entry points, i.e. command line commands available after installing the package
# e.g. implemented using argparse
# Then you can type: `python-package-hello -h` in the terminal
[project.scripts]
python-package-hello = "python_package.cli:main"
